Bug 484128 - Provide i2c-dev.h with inline userspace functions
Provide i2c-dev.h with inline userspace functions
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: i2c-tools (Show other bugs)
11
All Linux
low Severity medium
: ---
: ---
Assigned To: Adam Jackson
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-02-04 17:33 EST by Tim Niemueller
Modified: 2017-08-26 17:34 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 07:11:51 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Tim Niemueller 2009-02-04 17:33:26 EST
Description of problem:
I just ran across a piece of robot hardware which has source code available for using it (hooray!). But it needs i2c and for this the i2c-dev.h header with the inline defined functions otherwise hidden in the kernel guts.

Version-Release number of selected component (if applicable):
i2c-tools-3.0.2-1

Desired solution:
The i2c-dev.h header from i2c-tools should be made available. Actually I'm not sure about the best way, maybe this should be added as a kernel patch. Otherwise the kernel should not install that particular header and it could be in a i2c-devel package. The i2c-dev.h that comes with the kernel headers is pretty much useless. The one from i2c-tools is a super set of what is in kernel headers and provides everything needed. Debian provides this as libi2c-dev, which contains this specific kernel header.
Comment 1 Bug Zapper 2009-06-09 07:04:22 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 11 development cycle.
Changing version to '11'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Tim Niemueller 2009-06-11 18:54:41 EDT
Any progress or comments on this one?
Comment 3 Tim Niemueller 2010-02-11 13:28:43 EST
This still persists for F-12 and also Rawhide. Are you willing to fix this?
Comment 4 Bug Zapper 2010-04-27 08:51:55 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Bug Zapper 2010-06-28 07:11:51 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 6 MK 2017-04-23 10:58:21 EDT
This was never fixed and continues to be an issue on Fedora 25.

There are two forms of the i2c-dev.h header, a stock one which does not provide an interface to the smbus protocol:

https://www.kernel.org/doc/Documentation/i2c/smbus-protocol

And one which does (this is mentioned in the above document). As per the original post here, on Debian derived systems the full version, against which software using the interface can be compiled, is in the 'libi2c-dev' package.

There is some indication here:

https://github.com/groeck/i2c-tools/commit/daf0466e26f96280722df40e9fb4f8c50d44c2b6

That (presumably to mitigate confusion) the header would be moved to 'include/i2c/smbus.h' instead, however, nothing further seems to have happened since 2012 and as far as I am aware no linux system uses that path.  Also, this file is not available in any distro packaging of i2c-tools including Fedora's.

Hence, THE HEADER IS NOT AVAILABLE IN ANY FEDORA PACKAGE.  This means in order to compile software which requires it, it must be copied in from somewhere (e.g., a Debian install).  The header just defines wrappers on ioctl(), and so does not require an actual userspace library (i.e., the functionality is in the kernel).
Comment 7 Trevor Davenport 2017-08-26 17:34:35 EDT
This appears to still be an issue on F26.

Note You need to log in before you can comment on or make changes to this bug.